import numpy as np
from   matplotlib.colors import ListedColormap,LinearSegmentedColormap

# opt_color_type = 0: descrete colormap
# opt_color_type = 1: continuous colormap
def set_jma_rain(opt_color_type,transparent=1):
    
    ### setting for color of shade ####
    jmacolors=np.array(
        [[242,242,242,transparent],#white
         [160,210,255,transparent],
         [33 ,140,255,transparent],
         [0  ,65 ,255,transparent],
         [250,245,0,transparent],
         [255,153,0,transparent],
         [255,40,0,transparent],
         [180,0,104,transparent]],dtype=np.float32)
    jmacolors[:,:3] /=256
    jmacmap=ListedColormap(jmacolors)
    jmacmap2=LinearSegmentedColormap.from_list("jmacmap2",colors=jmacolors)

    jmacmap.set_bad(color='gray')
    jmacmap2.set_bad(color='gray')
    
    if opt_color_type == 0:
        return jmacmap
    elif opt_color_type == 1:
        return jmacmap2

def set_Blue2White(opt_color_type,transparent=1):

    RHcolors=np.array(
        [[235,255,235,transparent],#white
         [197,255,212,transparent],
         [120,210,200,transparent],
         [75,170,186,transparent],
         [50,130,172,transparent],
         [25,90,158,transparent]],dtype=np.float32)
    RHcolors[:,:3] /=256
    RHcmap=ListedColormap(RHcolors)
    RHcmap2=LinearSegmentedColormap.from_list("RHcmap2",colors=RHcolors)

    RHcmap.set_bad(color='gray')
    RHcmap2.set_bad(color='gray')
    
    if opt_color_type == 0:
        return RHcmap
    elif opt_color_type == 1:
        return RHcmap2

def set_Blue2Red(opt_color_type,transparent=1):

    Wcolors=np.array(
        [[25,90,158,transparent],
         [50,130,172,transparent],
         [75,170,186,transparent],
         [100,210,200,transparent],
         [127,255,212,transparent],
         [255,255,255,transparent],
         [245,245,190,transparent],
         [255,255,150,transparent],
         [255,200,125,transparent],
         [255,150,100,transparent],
         [255,90,9,1]],dtype=np.float32)
    Wcolors[:,:3] /=256
    Wcmap=ListedColormap(Wcolors)
    Wcmap2=LinearSegmentedColormap.from_list("Wcmap2",colors=Wcolors)    

    Wcmap.set_bad(color='gray')
    Wcmap2.set_bad(color='gray')

    if opt_color_type == 0:
        return Wcmap
    elif opt_color_type == 1:
        return Wcmap2
